/* main.js */

var dc = {};

dc.tools = {};

dc.tools.getStyle = function( obj,attr ){

	return obj.currentStyle ? obj.currentStyle[attr] : getComputedStyle( obj,false )[attr];

};

dc.tools.getByClass = function( oParent,sClass ){

	var aEle = oParent.getElementsByTagName( '*' );
	var arr = [];

	for( var i=0;i<aEle.length;i++ ){

		if( aEle[i].className == sClass ){

			arr.push( aEle[i] );

		}
	}

	return arr;
};

dc.ui = {};

dc.ui.fadeIn = function( obj ){

	var iCur = dc.tools.getStyle( obj,'opacity' );

	if( iCur == 1 ){ return false; }

	var value = 0;

	clearInterval( obj.timer);

	obj.timer = setInterval( function(){

		var iSpeed = 5;

		if( value == 100 ){
			clearInterval( obj.timer );
		}else{

			value += iSpeed;
			obj.style.opacity = value/100;
			obj.style.filter = 'alpha( opacity='+ value +' )';

		}

	},30 );

}

dc.ui.fadeOut = function( obj ){

	var iCur = dc.tools.getStyle( obj,'opacity' );

		if( iCur == 0 ){ return false; }

		var value = 100;

		clearInterval( obj.timer);

		obj.timer = setInterval( function(){

			var iSpeed = -5;

			if( value == 0 ){
				clearInterval( obj.timer );
			}else{

				value += iSpeed;
				obj.style.opacity = value/100;
				obj.style.filter = 'alpha( opacity='+ value +' )';

			}

		},30 );
};


dc.ui.doMove = function ( obj, attr, dir, tar, endFn ){
		
	dir = parseInt( dc.tools.getStyle( obj,attr ) )< tar ? dir : -dir ; 
	
	clearInterval( obj.timer );
	
	obj.timer = setInterval( function (){
		
		var iSpeed = parseInt( dc.tools.getStyle( obj,attr ) )+ dir ;
		
		if( iSpeed > tar && dir > 0 || iSpeed < tar && dir < 0 ){
			iSpeed = tar;
		}
		
		obj.style[attr] = iSpeed + 'px'; 
		
		if( iSpeed == tar ){
			clearInterval( obj.timer );
			endFn && endFn();
		}
			
	}, 50 );
};


dc.app = {};

dc.app.toBanner = function(){

	var oBanner = document.getElementById( 'banner' );
	var oUl = oBanner.getElementsByTagName( 'ul' )[0];
	var aLi = oUl.getElementsByTagName( 'li' );
	var aA = oUl.getElementsByTagName( 'a' );

	var iNow = 0;

	var timer = setInterval( auto,3000 );

	function auto(){

		if( iNow == aLi.length-1 ){
			iNow = 0;
		}else{
			iNow++;
		}

		for( var i=0;i<aLi.length;i++ ){

			dc.ui.fadeOut( aLi[i] );

		}

		dc.ui.fadeIn( aLi[iNow] );

	};
};

dc.app.toRun = function( oParent,oUl,oLi ){

	var oSolution_list = document.getElementById( oParent );
	var oUl = oSolution_list.getElementsByTagName( oUl )[0];
	var aLi = oUl.getElementsByTagName( oLi );

	var oPrev_btn = dc.tools.getByClass( oSolution_list,'prev_btn' )[0];
	var oNext_btn = dc.tools.getByClass( oSolution_list,'next_btn' )[0];

	var oneSize = aLi[0].offsetWidth;
	var iNow = 0;

	oUl.innerHTML +=oUl.innerHTML;
	oUl.style.width = oneSize * aLi.length +'px';

	oPrev_btn.onclick = function(){

		if( iNow == 0 ){

			iNow = aLi.length/2;
			oUl.style.left  = -oUl.offsetWidth/2+'px';

		}

		dc.ui.doMove( oUl,'left',26,-(iNow-1 )* oneSize );
		iNow--;

	};

	oNext_btn.onclick = function(){

		if( iNow == aLi.length/2 ){

			iNow = 0;
			oUl.style.left  = 0;

		}

		dc.ui.doMove( oUl,'left',26,-(iNow+1 )* oneSize );
		iNow++;

	};

};

dc.app.toRun1 = function(){

	var oSolution_list = document.getElementById( 'year' );
	var oUl = oSolution_list.getElementsByTagName( 'ul' )[0];
	var aLi = oUl.getElementsByTagName( 'li' );

	var oAchieve_list = document.getElementById( 'achieve_list' );
	var aUl = oAchieve_list.getElementsByTagName( 'ul' );

	var oPrev_btn = dc.tools.getByClass( oSolution_list,'prev_btn' )[0];
	var oNext_btn = dc.tools.getByClass( oSolution_list,'next_btn' )[0];

	var oneSize = aLi[0].offsetWidth;
	var iNow = 0;


	oUl.innerHTML +=oUl.innerHTML;
	oUl.style.width = oneSize * aLi.length +'px';

	oPrev_btn.onclick = function(){

		if( iNow == 0 ){

			iNow = aLi.length/2;
			oUl.style.left  = -oUl.offsetWidth/2+'px';

		}

		dc.ui.doMove( oUl,'left',16,-(iNow-1 )* oneSize );
		iNow--;

	};

	oNext_btn.onclick = function(){

		if( iNow == aLi.length/2 ){

			iNow = 0;
			oUl.style.left  = 0;

		}

		dc.ui.doMove( oUl,'left',16,-(iNow+1 )* oneSize );
		iNow++;

	};

	for( var i=0;i<aLi.length;i++ ){

 		aLi[i].index = i%5;
 		aLi[i].onclick = function(){

			for( var i=0;i<aLi.length;i++ ){
				
 				aLi[i].className = '';
 				
 				aUl[i%5].style.display = 'none';

 			}

 			aLi[this.index].className = 'active';
 			aUl[this.index].style.display = 'block';
 		};
 	}


};
dc.app.toPlay = function(){

	var oPro_con = document.getElementById( 'pro_con' );
	var oUl = oPro_con.getElementsByTagName( 'ul' )[0];
	var aLi = oUl.getElementsByTagName( 'li' );
	var oOl = oPro_con.getElementsByTagName( 'ol' )[0];
	var aA = oOl.getElementsByTagName( 'a' );

	var num = 0;

	var timer1 = setInterval( auto1,2000 );

	oPro_con.onmouseover = function(){
		clearInterval( timer1 );
	};
	oPro_con.onmouseout = function(){
		timer1 = setInterval( auto1,2000 );
	};

	for( var i=0; i<aA.length;i++ ){

		aA[i].index = i;
		aA[i].onclick = function(){

			for( var i=0;i<aLi.length;i++ ){
				aA[i].className = '';
				dc.ui.fadeOut( aLi[i] );
			}

			num = this.index;
			aA[num].className = 'active';
			dc.ui.fadeIn( aLi[num] );
		};

	}

	function auto1(){

		if( num == aA.length-1 ){
			num = 0;
		}else{
			num++;
		}

		for( var i=0;i<aA.length;i++ ){
			aA[i].className = '';
			dc.ui.fadeOut( aLi[i] );
		}

		aA[num].className = 'active';
		dc.ui.fadeIn( aLi[num] );

	};

};

dc.app.toChoise = function(){

	var oPs_wrap = document.getElementById( 'ps_wrap' );
	var aDd = oPs_wrap.getElementsByTagName( 'dd' );
	var aUl = oPs_wrap.getElementsByTagName( 'ul' );
	var aH3 = oPs_wrap.getElementsByTagName( 'h3' );

	for( var i=0;i<aUl.length;i++ ){

		aDd[i].index = i;
		aDd[i].onclick = function( ev ){
			//alert(1);

			var ev = ev || window.event;
			var This = this;

			for( var i=0;i<aUl.length;i++ ){

				aUl[i].style.display = 'none';

			}

			aUl[this.index].style.display = 'block';

			document.onclick = function(){

				aUl[This.index].style.display = 'none';

			};

			ev.cancelBubble = true;

		};
	}

	for( var i=0;i<aUl.length;i++ ){

		aUl[i].index = i;

		(function(ul){

			var aLi = ul.getElementsByTagName( 'li' );

			for( var i=0;i<aLi.length;i++ ){

				aLi[i].onmouseover = function(){
					this.className = 'active';
				};

				aLi[i].onmouseout = function(){
					this.className = '';
				};

				aLi[i].onclick = function(ev){

				var ev = ev || window.event;

				aH3[this.parentNode.index].innerHTML = this.innerHTML;
				ev.cancelBubble = true;
				this.parentNode.style.display = 'none';
			};

			}


		})(aUl[i])


	}
};

dc.app.toOpen = function(){

	var oDc_side = document.getElementById( 'dc_side' );
	var aH4 = oDc_side.getElementsByTagName( 'h4' );
	var aDl = oDc_side.getElementsByTagName( 'dl' );
	var aSpan = oDc_side.getElementsByTagName( 'span' );

	for( var i=0;i<aH4.length;i++ ){

		aH4[i].index = i;

		aH4[i].onclick = function(){

			for( var i=0;i<aDl.length;i++ ){

				aDl[i].style.display = 'none';
				aH4[i].style.display = 'block';
				aSpan[i].style.display = 'block';

			}

			aH4[this.index].style.display = 'none';
			aSpan[this.index].style.display = 'none';
			aDl[this.index].style.display = 'block';

		}
	}

};